#!/usr/bin/perl
# vec_4bits.pl

foreach my $bit_length ( qw( 4 2 1 ) ) {
    print "Bit length is $bit_length\n";
    my $last    = (16 / $bit_length) - 1;
    my $on_bits = oct( "0b" . "1" x $bit_length );

    foreach my $index ( 0 .. $last ) {
        my $string = "\000\000";

        vec( $string, $index, $bit_length ) = $on_bits;

        printf "%2d: ", $index;
        print show_string( $string ), "\n    ", show_ord( $string ), "\n";
        }
    print "\n";
    }

sub show_string {
    unpack( "b*", $_[0] );
    }

sub show_ord {
    my $result = '';

    foreach my $byte ( split //, $_[0] ) {
        $result .= sprintf "%08b", ord($byte);
        }

    $result;
    }