#!/usr/bin/perl
# basic_arithmetic.pl
use v5.10;
use strict;

REPL: while( 1 ) {
    my( $operator, @operands ) = get_line();

       if( $operator eq '+' ) { add(      @operands ) }
    elsif( $operator eq '-' ) { subtract( @operands ) }
    elsif( $operator eq '*' ) { multiply( @operands ) }
    elsif( $operator eq '/' ) { divide(   @operands ) }
    else {
        print "No such operator [$operator]!\n";
        last REPL;
        }
    }

print "Done, exiting...\n";

sub get_line {
    # This could be a lot more complicated, but this isn't the point
    print "\nprompt> ";

    my $line = <STDIN>;

    $line =~ s/^\s+|\s+$//g;

    ( split /\s+/, $line )[1,0,2];
    }

sub add      { say $_[0] + $_[1] }

sub subtract { say $_[0] - $_[1] }

sub multiply { say $_[0] * $_[1] }

sub divide   { say $_[1] ? $_[0] / $_[1] : 'NaN' }