#!/usr/bin/perl
# other_package_croak.pl

Local::Math->divide(1, 2);
Local::Math->divide(3, 4);
Local::Math->divide(4);
Local::Math->divide(5, 7);

package Local::Math {
    sub divide {
        my( $class, $numerator, $denominator ) = @_;
        Local::BaseMath::_divide( $numerator, $denominator );
        }
    }

package Local::BaseMath {
    use Carp qw(croak);

    sub _divide {
        croak q(Can't divide by zero!) if $_[1] == 0;
        $_[0] / $_[1]
        }
    }